# 内存管理：

### 1.内存分页：

内存分页是指将物理内存划分成固定大小的页框（page frame），通常是4KB大小的页面。物理内存的地址空间被划分为一系列大小相等的页框，每个页框可以容纳一个页的数据。内存分页的目的是将物理内存划分成固定大小的块，方便管理和分配。在RISC-V架构下，内存分页的启用和禁用通过设置`satp`寄存器中的标志位实现，当启用分页时，处理器将使用页表进行虚拟内存映射，否则将直接使用物理地址。

### 2.虚拟内存映射：

这个系统实现了虚拟内存映射，将每个进程的虚拟地址空间映射到物理内存中。每个进程都有自己的页表（page table），用于将虚拟地址映射到物理地址。当一个进程访问虚拟地址时，处理器会使用页表将虚拟地址转换为对应的物理地址。如果该虚拟地址没有映射到物理地址，处理器会触发缺页异常（page fault），操作系统将负责处理该异常，通常包括分配一个新的物理页框，然后更新页表以建立虚拟地址到物理地址的映射关系。

系统采用了两级页表（two-level page table）的方式进行虚拟内存映射。页表包括两个层级：页目录表（Page Directory Table，PDT）和页表（Page Table，PT）。页目录表中的每个条目指向一个页表，而页表中的每个条目指向一个页框。使用两级页表可以节省内存空间，因为每个页表条目只需要占用一个字节，而不是一个页面。此外，两级页表还能提高查找速度，因为只有两次查找就可以找到虚拟地址对应的物理页框。

### 3.页面置换：

系统采用最简单的页面置换算法——FIFO（First-In-First-Out）。以支持更多进程的运行。当物理内存不足时，操作系统会选择最早进入物理内存的页面进行置换，即最先进入物理内存的页面将被替换出去。这样简单的页面置换算法能够较为高效地处理页面置换的问题，但是可能导致较大的内存碎片和性能问题。

内存管理部分实现了内存分页、虚拟内存映射和页面置换等功能。通过内存分页和虚拟内存映射，实现了进程间的隔离和内存保护，每个进程都有独立的虚拟地址空间。而页面置换机制则确保了操作系统可以支持更多进程的运行。

 

参考文献：

\1. RISC-V Instruction Set Manual Volume II: Privileged Architecture，版本1.11，编者：Andrew Waterman，Krste Asanović等，2019年。

 

\2. xv6-riscv官方文档：https://pdos.csail.mit.edu/6.828/2020/xv6.html。